#include "stdafx.h"
#include "sinstance.h"
#include "MyFrameWnd.h"


class CMyApp : public CWinApp
{
public:
  CMyApp();

protected:
//Member variables
  CInstanceChecker m_InstanceChecker;

//Methods
  BOOL InitInstance() override;
};


//the one and only app
#pragma warning(suppress: 26426)
CMyApp theApp;


#pragma warning(suppress: 26455)
CMyApp::CMyApp() : m_InstanceChecker{_T("{A84F50BD-59DF-43F4-A8F9-6C83EDB9CAE5}")}
{
}

BOOL CMyApp::InitInstance()
{
  //Check for the previous instance as soon as possible
  if (m_InstanceChecker.PreviousInstanceRunning())
  {
    CCommandLineInfo cmdInfo;
    ParseCommandLine(cmdInfo);

    AfxMessageBox(_T("Previous version detected, will now restore it"), MB_OK | MB_ICONINFORMATION);
    m_InstanceChecker.ActivatePreviousInstance(cmdInfo.m_strFileName);
    return FALSE;
  }

  //Standard MFC stuff, create the mainframe
#pragma warning(suppress: 26409)
  CFrameWnd* pMainFrm{new CMyFrameWnd()};
  if (!pMainFrm->Create(nullptr, m_pszAppName))
    return FALSE;
  pMainFrm->ShowWindow(SW_SHOW);
  m_pMainWnd = pMainFrm;

  //If this is the first instance of our App then track it so any other instances can find us
  m_InstanceChecker.TrackFirstInstanceRunning(m_pMainWnd->GetSafeHwnd());

  //For testing purposes check the functions again to make sure they work when calling later on
  //in an apps lifetime
#ifdef _DEBUG
  const bool bPrevInstance{m_InstanceChecker.PreviousInstanceRunning()};
  UNREFERENCED_PARAMETER(bPrevInstance);
  const bool bTrack{m_InstanceChecker.TrackFirstInstanceRunning(m_pMainWnd->GetSafeHwnd())};
  UNREFERENCED_PARAMETER(bTrack);
#endif

  return TRUE;
}
